/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20190617

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#define YYPREFIX "yy"

#define YYPURE 0

#line 4 "bibparse.y"
 /**********************************************************************
 @Yacc-file{
    author              = "Nelson H. F. Beebe",
    version             = "1.14",
    date                = "01 July 2021",
    time                = "16:47:06 MDT",
    filename            = "bibparse.y",
    address             = "University of Utah
                           Department of Mathematics, 110 LCB
                           155 S 1400 E RM 233
                           Salt Lake City, UT 84112-0090
                           USA",
    telephone           = "+1 801 581 5254",
    FAX                 = "+1 801 581 4148",
    URL                 = "http://www.math.utah.edu/~beebe",
    checksum            = "44544 725 2201 17931",
    email               = "beebe@math.utah.edu, beebe@acm.org,
                           beebe@computer.org (Internet)",
    codetable           = "ISO/ASCII",
    keywords            = "BibTeX, bibliography, lexical analysis, lexer,
                           parsing, parser",
    license             = "public domain",
    supported           = "yes",
    docstring           = "This yacc file defines a parser for a
                           prototype BibTeX grammar.

                           The resulting program reads BibTeX data,
                           and/or BibTeX lexical token streams produced
                           by biblex or bibclean, from one or more files
                           specified on the command line, or standard
                           input, and parses the token stream to verify
                           its conformance to the BibTeX grammar.

                           If a command-line -d (or -D) option is
                           specified, debug mode is selected, and
                           extensive commentary on the parsing actions
                           will be output.  It will be necessary to
                           have a copy of the y.output file produced
                           by bison or lex in order to make sense out
                           of the state and rule numbers in this
                           output.

                           The checksum field above contains a CRC-16
                           checksum as the first value, followed by the
                           equivalent of the standard UNIX wc (word
                           count) utility output of lines, words, and
                           characters.  This is produced by Robert
                           Solovay's checksum utility.",
 }
 **********************************************************************/

#include <config.h>

#include <stdio.h>
#include <string.h>
#include <ctype.h>

#if defined(HAVE_STDLIB_H)
#include <stdlib.h>
#endif

#if HAVE_ALLOCA_H
 /* needed for alloca() macro definition if bison is used instead of yacc */
#include <alloca.h>
#endif

#include "args.h"
#include "bibyydcl.h"

#undef MAX
#define MAX(a,b)	(((a) >= (b)) ? (a) : (b))

#undef TOLOWER
#define TOLOWER(c)	(isupper(c) ? tolower(c) : (c)) /* guard against broken tolower() on ancient systems */

static void		doparse ARGS((void));
int			main ARGS((int argc_, char *argv_[]));
static int		match_option ARGS((const char *s, const char *t, int nmax));
static int		nextchar ARGS((void));
static void		recognize ARGS((const char *s_));
static void		show_help_and_exit ARGS((void));
static void		show_version_and_exit ARGS((void));
int			yyparse ARGS((void));
static void		yywarning ARGS((const char *s_));

#if defined(__cplusplus)
extern "C" {
#endif

static int		(*pyylex) ARGS((void));
int			xxlex ARGS((void));
int			zzlex ARGS((void));

#if defined(__cplusplus)
}
#endif

int			error_count;
char			*program_name;	/* for error messages */

/* These variables are defined in biblex.c: */
extern int		do_lex_output;
extern long int		line_number;
extern long int		start_line_number;
extern const char	*the_filename;
extern char		yytext[BIBYYLMAX];

#define	ERROR_PREFIX	"??"	/* this prefixes all error messages */
#define WARNING_PREFIX	"%%"	/* this prefixes all warning messages */

#define RECOGNIZE(s)	recognize(s)

#define YYDEBUG		1		/* need for -d option support */

#if defined(_CRAY)
extern long yydebug;
#else
extern int yydebug;
#endif

#line 142 "y.tab.c"

#if ! defined(YYSTYPE) && ! defined(YYSTYPE_IS_DECLARED)
/* Default: YYSTYPE is the semantic value type. */
typedef int YYSTYPE;
# define YYSTYPE_IS_DECLARED 1
#endif

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define TOKEN_ABBREV 1
#define TOKEN_AT 2
#define TOKEN_COMMA 3
#define TOKEN_COMMENT 4
#define TOKEN_ENTRY 5
#define TOKEN_EQUALS 6
#define TOKEN_FIELD 7
#define TOKEN_INCLUDE 8
#define TOKEN_INLINE 9
#define TOKEN_KEY 10
#define TOKEN_LBRACE 11
#define TOKEN_LITERAL 12
#define TOKEN_NEWLINE 13
#define TOKEN_PREAMBLE 14
#define TOKEN_RBRACE 15
#define TOKEN_SHARP 16
#define TOKEN_SPACE 17
#define TOKEN_STRING 18
#define TOKEN_VALUE 19
#define YYERRCODE 256
typedef short YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    2,    2,    3,    4,    4,    4,    4,    4,
    4,    5,    6,    6,    6,   10,   12,   12,    7,    8,
    9,   13,   16,   17,   13,   15,   15,   11,   11,   19,
   14,   18,   18,    1,    1,   20,   20,   21,   21,   21,
};
static const YYINT yylen[] = {                            2,
    1,    3,    1,    3,    3,    1,    1,    1,    1,    1,
    2,    3,    3,    5,    2,    8,    1,    1,    3,    7,
    7,    1,    0,    0,    7,    1,    1,    1,    4,    0,
    7,    1,    1,    0,    1,    1,    2,    1,    1,    1,
};
static const YYINT yydefred[] = {                         0,
   39,   40,   38,    0,    0,    0,   36,    0,    0,    3,
   37,    0,    0,    0,    0,    0,    0,    0,    0,    5,
    6,    7,    8,    9,   10,    0,    4,   11,    0,    0,
    0,    0,    0,   33,   32,   15,    0,   28,    0,   12,
    0,   19,    0,    0,    0,   13,    0,    0,    0,    0,
    0,    0,   18,   17,    0,   27,   26,    0,   22,    0,
   14,   29,   30,    0,    0,    0,    0,    0,   20,    0,
   21,    0,   16,   24,    0,    0,    0,   25,
};
static const YYINT yydgoto[] = {                          4,
    5,    9,   10,   20,   21,   22,   23,   24,   25,   26,
   37,   55,   58,   38,   59,   70,   76,   39,   67,    6,
    7,
};
static const YYINT yysindex[] = {                        63,
    0,    0,    0,    0,   53,   63,    0,   63,   63,    0,
    0,   17,   53,   14,   63,   63,   63,   63,   63,    0,
    0,    0,    0,    0,    0,   49,    0,    0,   48,   56,
   67,   70,   78,    0,    0,    0,   11,    0,   63,    0,
   63,    0,   63,   63,   63,    0,   85,   58,   -1,   76,
   50,   63,    0,    0,   63,    0,    0,   63,    0,   63,
    0,    0,    0,   89,   79,   80,   -1,   63,    0,   81,
    0,   63,    0,    0,    0,   63,   -1,    0,
};
static const YYINT yyrindex[] = {                        32,
    0,    0,    0,    0,   93,    1,    0,   19,   32,    0,
    0,    0,   96,    0,   87,   90,   87,   90,   90,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   94,    0,
   60,    0,    9,   77,   51,    0,    0,    0,    0,    0,
    0,    9,    0,    0,  100,    0,    0,   47,    0,   92,
    0,    0,    0,    0,   88,    0,    0,   51,    0,    0,
    0,   38,    0,    0,   27,    9,    0,    0,
};
static const YYINT yygindex[] = {                         0,
   30,    0,   95,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   42,   36,   28,    0,    0,    0,    0,    0,
  104,
};
#define YYTABLESIZE 275
static const YYINT yytable[] = {                         56,
   35,   35,   35,   35,   35,   35,   35,   35,   35,   34,
   35,   35,   35,   45,   35,   35,   35,   57,   35,   35,
   15,   16,   34,   34,   17,   46,   34,   34,   28,   31,
   18,   34,   34,   34,   19,   31,   34,   12,   13,   31,
   34,   31,   23,   31,   29,   30,   31,   32,   33,   34,
   34,   34,   34,   34,    8,   35,   35,   34,   53,   40,
   34,   34,   34,   36,   61,   34,   41,   54,   47,   34,
   48,    1,   49,   50,   51,    2,   34,   34,   42,    3,
   43,   63,   35,   34,   64,   60,   62,   65,   44,   66,
   52,   68,    1,   69,   71,    2,   74,   73,   34,   34,
   34,   75,   34,   23,   78,   77,   34,   27,   72,   11,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   35,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   14,    0,   34,
};
static const YYINT yycheck[] = {                          1,
    0,    1,    2,    3,    4,    5,    6,    7,    8,    1,
   10,   11,   12,    3,   14,   15,   16,   19,   18,   19,
    4,    5,    4,    5,    8,   15,    8,   19,   15,    3,
   14,    0,   14,    2,   18,    9,   18,    8,    9,   13,
    3,   15,   16,   17,   15,   16,   17,   18,   19,    1,
    1,    1,   15,   16,    2,    7,    7,    7,    1,   12,
    1,   15,   16,   15,   15,   15,   11,   10,   39,   10,
   41,    9,   43,   44,   45,   13,    1,    1,   12,   17,
   11,   52,    7,    7,   55,   50,   51,   58,   11,   60,
    6,    3,    0,   15,   15,    0,   16,   68,   12,    6,
   11,   72,    3,   16,   77,   76,   15,   13,   67,    6,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  256,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  256,   -1,  256,
};
#define YYFINAL 4
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 256
#define YYUNDFTOKEN 280
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"end-of-file","TOKEN_ABBREV","TOKEN_AT","TOKEN_COMMA","TOKEN_COMMENT",
"TOKEN_ENTRY","TOKEN_EQUALS","TOKEN_FIELD","TOKEN_INCLUDE","TOKEN_INLINE",
"TOKEN_KEY","TOKEN_LBRACE","TOKEN_LITERAL","TOKEN_NEWLINE","TOKEN_PREAMBLE",
"TOKEN_RBRACE","TOKEN_SHARP","TOKEN_SPACE","TOKEN_STRING","TOKEN_VALUE",0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : file",
"file : opt_space",
"file : opt_space object_list opt_space",
"object_list : object",
"object_list : object_list opt_space object",
"object : TOKEN_AT opt_space at_object",
"at_object : comment",
"at_object : entry",
"at_object : include",
"at_object : preamble",
"at_object : string",
"at_object : error TOKEN_RBRACE",
"comment : TOKEN_COMMENT opt_space TOKEN_LITERAL",
"entry : entry_head assignment_list TOKEN_RBRACE",
"entry : entry_head assignment_list TOKEN_COMMA opt_space TOKEN_RBRACE",
"entry : entry_head TOKEN_RBRACE",
"entry_head : TOKEN_ENTRY opt_space TOKEN_LBRACE opt_space key_name opt_space TOKEN_COMMA opt_space",
"key_name : TOKEN_KEY",
"key_name : TOKEN_ABBREV",
"include : TOKEN_INCLUDE opt_space TOKEN_LITERAL",
"preamble : TOKEN_PREAMBLE opt_space TOKEN_LBRACE opt_space value opt_space TOKEN_RBRACE",
"string : TOKEN_STRING opt_space TOKEN_LBRACE opt_space assignment opt_space TOKEN_RBRACE",
"value : simple_value",
"$$1 :",
"$$2 :",
"value : value opt_space $$1 TOKEN_SHARP $$2 opt_space simple_value",
"simple_value : TOKEN_VALUE",
"simple_value : TOKEN_ABBREV",
"assignment_list : assignment",
"assignment_list : assignment_list TOKEN_COMMA opt_space assignment",
"$$3 :",
"assignment : assignment_lhs opt_space TOKEN_EQUALS opt_space $$3 value opt_space",
"assignment_lhs : TOKEN_FIELD",
"assignment_lhs : TOKEN_ABBREV",
"opt_space :",
"opt_space : space",
"space : single_space",
"space : space single_space",
"single_space : TOKEN_SPACE",
"single_space : TOKEN_INLINE",
"single_space : TOKEN_NEWLINE",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 366 "bibparse.y"

const char *Last_Recognized = "";

/* end of grammar */

static void
doparse(VOID)
{		/* parse a complete BibTeX file or BibTeX token stream */
    int c;

    line_number = 1L;

    /* A single character lookahead distinguishes between a token
    stream, which starts with a line number directive, and a BibTeX
    file, which does not.  We then pick a suitable lexical analyzer
    function. */

    c = getchar();
    (void)ungetc(c,stdin);
    pyylex = (c == '#') ? zzlex : xxlex;

    yyparse();				/* this handles the entire file */
}


#if NEW_STYLE
int
main(int argc, char *argv[])
#else /* K&R style */
int
main(argc, argv)
int argc;
char *argv[];
#endif /* NEW_STYLE */
{
    int code;				/* error return code */
    int k;				/* index into argv[] */
    int n;				/* index into argv[] */
    FILE *fp;				/* pointer to current input file */

    do_lex_output = 0;			/* prevent output from xxlex() */
    error_count = 0;
    program_name = argv[0];
    yydebug = 0;

    for (k = 1; k < argc; ++k)
    {					/* check for command-line options */
	const char *this_arg;

	this_arg = argv[k];

	/* Accept both "-arg" and GNU-style "--arg" */

	if ( (this_arg[0] == '-') && (this_arg[1] == '-') )
	    this_arg++;			/* change "--arg" to "-arg" */

	if (match_option(this_arg, "-debug", MAX(2, strlen(this_arg))))
	{
	    yydebug = 1;
	    do_lex_output = 1;

	    for (n = k; n < argc; ++n)	/* shuffle remaining arguments down */
		argv[n] = argv[n+1];

	    argc--;			/* and reduce argument count */
	}
	else if (match_option(this_arg, "-help", MAX(2, strlen(this_arg))))
	    show_help_and_exit();
	else if (match_option(this_arg, "-version", MAX(2, strlen(this_arg))))
	    show_version_and_exit();
    }

    if (argc > 1)		/* files to parse named on command line */
    {
	for (k = 1; k < argc; ++k)
	{
	    fp = freopen(argv[k],"r",stdin);

	    if (fp == (FILE*)NULL)
	    {
		(void)fprintf(stderr,
			      "\n%s Ignoring open failure on file [%s]\n",
			      ERROR_PREFIX, argv[k]);
		(void)perror("perror() says");
	    }
	    else
	    {
		the_filename = argv[k];
		doparse();
		(void)fclose(fp);
	    }
	}
    }
    else				/* parse stdin */
    {
	the_filename = "stdin";
	doparse();
    }
    code = (error_count > 0) ? EXIT_FAILURE : EXIT_SUCCESS;

    exit(code);

    return (code);			/*NOTREACHED*/
}


#if NEW_STYLE
static int
match_option(const char *s, const char *t, int nmax)
#else /* K&R style */
static int
match_option(s, t, nmax)
const char *s;
const char *t;
int nmax;
#endif /* NEW_STYLE */
{
    int match, n;

    match = 1;		/* assume that s and t match, and then try to prove otherwise */

    for (n = 0; n < nmax; ++n)
    {
	if (TOLOWER(s[n]) != TOLOWER(t[n]))
	{
	    match = 0;
	    break;
	}
    }

    return (match);
}


static int
nextchar (VOID)
{
    int c;

    c = getchar ();

    if (yydebug)
	putchar (c);

    return (c);
}



#if NEW_STYLE
static void
recognize(const char *s)
#else
static void
recognize(s)
const char *s;
#endif
{
    Last_Recognized = s;

    if (yydebug)
	printf("[%s]\n", s);
}

static void
show_help_and_exit(VOID)
{
    static const char *help[] =
    {
	"\n",
	"Usage:\n\t",
	PACKAGE_NAME,
	" [ options ] [ infile(s) ]\n",
	"\n",
	"If there are no command-line files, then input is from stdin.\n",
	"\n",
	"Optional arguments:\n",
	"\n",
	"\t-d\tsend [voluminous] debug output to stdout\n",
	"\t-h\tprint brief help on stderr and exit with success\n",
	"\t-v\tprint version information on stderr and exit with success\n",
	"\n",
	"The GNU-style --debug, --help, and --version options are accepted,\n",
	"as are any unique prefixes of those long options.  Lettercase is not\n",
	"significant in option names.\n",
	"\n",
	"There is normally NO OUTPUT PRINTED (unless debugging is requested, or\n",
	"there are parse errors).  Instead, the program exit code records the\n",
	"parse status: zero for success, and nonzero for failure, used such as\n",
	"in these equivalent POSIX (Bourne-family) shell commands:\n",
	"\n",
	"\t",
	PACKAGE_NAME,
	" myfile.bib && make dist\n",
	"or\n",
	"\tif ",
	PACKAGE_NAME,
	" myfile.bib ; then make dist ; fi\n",
	"or\n",
	"\t",
	PACKAGE_NAME,
	" myfile.bib\n",
	"\tif test $? -eq 0 ; then make dist ; fi\n",
	"or\n",
	"\t",
	PACKAGE_NAME,
	" myfile.bib\n",
	"\tif [ $? -eq 0 ] ; then make dist ; fi\n",
	"\n",
	(const char *)NULL
    };
    int k;

    for (k = 0; help[k] != (const char *)NULL; ++k)
	(void)fprintf(stderr, "%s", help[k]);

    exit(EXIT_SUCCESS);
}


static void
show_version_and_exit(VOID)
{
    const char *version[] =
    {
	"This is ",
	PACKAGE_NAME,
	" version ",
	PACKAGE_VERSION,
	" ",
	PACKAGE_DATE,
	"\n\n",
	"Copyright (C) 1998--2021 by ",
	PACKAGE_AUTHOR,
	" and the Free Software Foundation, Inc.\n\n",
	PACKAGE_NAME,
	" is free software that you are free to change, redistribute, and\n",
	"mirror.  There is NO WARRANTY; not even for MERCHANTABILITY or FITNESS\n",
	"FOR A PARTICULAR PURPOSE.\n\n",
	"The software development master Web site is\n\n\t",
	PACKAGE_URL,
	"\n\n",
	"The software is distributed under the GNU General Public License (GPL),\n",
	"version 2 or later, available as the file COPYING in the program source\n",
	"distribution, and also at\n\n",
	"\thttp://www.gnu.org/copyleft/gpl.html\n\n",
	"Send bug reports to\n\n\t",
	PACKAGE_BUGREPORT,
	"\n\n",
	(const char *)NULL
    };
    int k;

    for (k = 0; version[k] != (const char *)NULL; ++k)
	(void)fprintf(stderr, "%s", version[k]);

    exit(EXIT_SUCCESS);
}


#if NEW_STYLE
void
yyerror(const char *s)
#else
void
yyerror(s)
const char *s;
#endif
{
    error_count++;
    (void)fflush(stdout);

    if (start_line_number > 0L)
	(void)fprintf(stderr,"%s:%ld:token start\n",
		      the_filename, start_line_number);

    (void)fprintf(stderr,"%s:%ld:%s\tnext token = [%s]\n",
		  the_filename, line_number, s, yytext);
    (void)fprintf(stderr, "%s:%ld:last token type recognized = %s\n",
		  the_filename, line_number, Last_Recognized);
    (void)fflush(stderr);
}


int
yylex (VOID)
{
    int v;

    v = (*pyylex) ();

    /* xxlex() (== yylex() in biblex.c) biases token values by 1000, but
       the token streams produced by biblex and "bibclean --no-prettyprint"
       exclude that bias, for compact output. */

    return ((pyylex == zzlex) ? v : (v - 1000));
}


#if NEW_STYLE
static void
yywarning(const char *s)
#else
static void
yywarning(s)
const char *s;
#endif
{
    (void)fflush(stdout);
    (void)fprintf(stderr,"%s:%ld:%s\tNext token = \"%s\"\n",
		  the_filename, line_number, s, yytext);
    (void)fflush(stderr);
}


int
zzlex (VOID)
{
    char buffer[BUFSIZ];	/* only needs space for a single number token */
    char *limit;		/* how far we can store into buffer[] */
    char *p;			/* pointer into buffer[] */
    int c;			/* current input character */

    limit = &buffer[sizeof(buffer) - 1]; /* address of last slot in buffer[] */

    for (;;)			/* `infinite' loop for ignoring comments and empty lines */
    {
	while (((c = nextchar ()) > 0) && isspace (c))
	    ;			/* skip leading whitespace */

	/* Collect first non-blank token on line, truncating if too big for buffer[] */
	p = &buffer[0];
	*p++ = c;

	while (((c = nextchar ()) > 0) && !isspace (c))
	{
	    if (p < limit)
		*p++ = c;
	}

	*p = '\0';

	while ((c != '\n') && ((c = nextchar ()) > 0))
	    ;			/* skip rest of line */

	if (c == '\n')		/* should always be true */
	    line_number++;

	if (buffer[0] == '#')	/* comment: pseudo return tail-recursively */
	    continue;
	else if (isdigit ((int) buffer[0]))	/* token number */
	    return ((int) strtol ((const char *) &buffer[0], &limit, 10));
	else if (c == '\n')	/* empty line: pseudo return tail-recursively */
	    continue;
	else if (feof (stdin))	/* assume end of file */
	    return (0);		/* standard lex end-of-file signal */
	else
	    return (-1);	/* should never happen */
    }
}
#line 783 "y.tab.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 1:
#line 233 "bibparse.y"
	{RECOGNIZE("file-1");}
break;
case 2:
#line 235 "bibparse.y"
	{RECOGNIZE("file-2");}
break;
case 3:
#line 239 "bibparse.y"
	{RECOGNIZE("object-1");}
break;
case 4:
#line 241 "bibparse.y"
	{RECOGNIZE("object-2");}
break;
case 5:
#line 245 "bibparse.y"
	{RECOGNIZE("object");}
break;
case 6:
#line 249 "bibparse.y"
	{RECOGNIZE("comment");}
break;
case 7:
#line 251 "bibparse.y"
	{RECOGNIZE("entry");}
break;
case 8:
#line 253 "bibparse.y"
	{RECOGNIZE("include");}
break;
case 9:
#line 255 "bibparse.y"
	{RECOGNIZE("preamble");}
break;
case 10:
#line 257 "bibparse.y"
	{RECOGNIZE("string");}
break;
case 11:
#line 259 "bibparse.y"
	{RECOGNIZE("error");}
break;
case 12:
#line 264 "bibparse.y"
	{RECOGNIZE("comment");}
break;
case 13:
#line 270 "bibparse.y"
	{RECOGNIZE("entry-1");}
break;
case 14:
#line 275 "bibparse.y"
	{RECOGNIZE("entry-2");}
break;
case 15:
#line 277 "bibparse.y"
	{RECOGNIZE("entry-3");}
break;
case 16:
#line 284 "bibparse.y"
	{RECOGNIZE("entry_head");}
break;
case 17:
#line 288 "bibparse.y"
	{RECOGNIZE("key_name-1");}
break;
case 18:
#line 290 "bibparse.y"
	{RECOGNIZE("key_name-2");}
break;
case 19:
#line 295 "bibparse.y"
	{RECOGNIZE("include");}
break;
case 20:
#line 302 "bibparse.y"
	{RECOGNIZE("preamble");}
break;
case 21:
#line 309 "bibparse.y"
	{RECOGNIZE("string");}
break;
case 22:
#line 313 "bibparse.y"
	{RECOGNIZE("value-1");}
break;
case 23:
#line 315 "bibparse.y"
	{RECOGNIZE("value-1-1");}
break;
case 24:
#line 317 "bibparse.y"
	{RECOGNIZE("value-1-2");}
break;
case 25:
#line 319 "bibparse.y"
	{RECOGNIZE("value-2");}
break;
case 26:
#line 323 "bibparse.y"
	{RECOGNIZE("simple_value-1");}
break;
case 27:
#line 325 "bibparse.y"
	{RECOGNIZE("simple_value-2");}
break;
case 28:
#line 329 "bibparse.y"
	{RECOGNIZE("single assignment");}
break;
case 29:
#line 333 "bibparse.y"
	{RECOGNIZE("assignment-list");}
break;
case 30:
#line 338 "bibparse.y"
	{RECOGNIZE("assignment-0");}
break;
case 31:
#line 340 "bibparse.y"
	{RECOGNIZE("assignment");}
break;
case 32:
#line 344 "bibparse.y"
	{RECOGNIZE("assignment_lhs-1");}
break;
case 33:
#line 346 "bibparse.y"
	{RECOGNIZE("assignment_lhs-2");}
break;
case 34:
#line 350 "bibparse.y"
	{RECOGNIZE("opt_space-1");}
break;
case 35:
#line 352 "bibparse.y"
	{RECOGNIZE("opt_space-2");}
break;
case 36:
#line 356 "bibparse.y"
	{RECOGNIZE("single space");}
break;
case 37:
#line 358 "bibparse.y"
	{RECOGNIZE("multiple spaces");}
break;
#line 1130 "y.tab.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
